/* -*- c++ -*- */
#ifndef AKAXISO_XML_EXPAT_EXPAT_DESERIALIZER_H__
#define AKAXISO_XML_EXPAT_EXPAT_DESERIALIZER_H__

#include <akaxiso/configuration.h>
#ifdef USE_EXPAT

#include <akaxiso/XML/deserializer/deserializer.h>
#include <akaxiso/imported/expat_parser.h>

namespace aka2 {

  class expat_deserializer : public deserializer {
  public:
    expat_deserializer() { }
    ~expat_deserializer() { }

    virtual document deserialize(std::istream &istm);
    virtual document deserialize(const char *document);
    virtual document deserialize(const std::string &document);
    virtual document deserialize_stdin();
    virtual document deserialize_file(const std::string &filename);

  private:
    document deserialize_chars(const char *buffer, int len,
			       const std::string &source_name);
    document deserialize_istream(std::istream &istm, const std::string &source_name);
  };

} // namespace aka2

#endif

#endif
